// Ceci est une version simplifiée du programme original suivant :
// http://www.pixelbeat.org/programming/stdio_buffering/default_buffers.c

// Il convient d'essayer les lignes suivants et observer les résultats :
//	./buffers
//	./buffers > /dev/null
//	./buffers 2> /dev/null

/* Output info about the default buffering parameters
 * applied by libc to stdin, stdout and stderr.
 * Note the info is sent to stderr, as redirecting it
 * makes no difference to its buffering parameters.
 * Note gnulib has fbufmode() to make this portable.
 */
#include <stdio_ext.h>
#include <unistd.h>
#include <stdlib.h>

int main(void)
{
	// Il faut un premier printf pour initialiser les stream.
	fprintf(stdout,"Initialising stdout\n");
	fprintf(stderr,"Initialising stderr\n");

	FILE *output = isatty(1)? stdout : stderr;

        fprintf(output,"stdout: tty=%d, linebuffered=%d, buffersize=%d\n",
                isatty(1), __flbf(stdout)?1:0, (int)__fbufsize(stdout));
        fprintf(output,"stderr: tty=%d, linebuffered=%d, buffersize=%d\n",
                isatty(2), __flbf(stderr)?1:0, (int)__fbufsize(stderr));

	return EXIT_SUCCESS;
}
