// Solution généralisée pour la Question 4a,
// pour N threads avec N-1 sémaphores.

// Le thread numéro i libère le sémaphore numéro i après avoir fini.

#include <pthread.h>
#include <stdio.h>
#include <semaphore.h>

#define N 9

pthread_t th[N];
sem_t s[N-1];

void* thread (void *arg)
{
	long int id = (long int) arg;

	// Attendre le thread précédent.
	if (id > 0) sem_wait(s+id-1);

	// Afficher son identifiant.
	printf("%ld\n",id);

	// Libérer le prochain thread.
	if (id < N-1) sem_post(s+id);

	return NULL;
}

int main ()
{
	// initialiser les sémaphores avec zéro créneaux
	long int i;
	for (i = 0; i < N-1; i++) sem_init(s+i,0,0);

	// lancer les threads
	for (i = 0; i < N; i++)
		pthread_create(th+i,NULL,thread,(void*)i);

	// ramasser tous les threads
	for (i = 0; i < N; i++)
		pthread_join(th[i],NULL);

	return 0;
}
